/* This is a slightly adapted version of Peter Anvin's vsnprintf()
 * implementation, found here:
 * http://svn.one-lab.org/bootcd/trunk/syslinux/com32/
 *
 * -----------------------------------------------------------------------
 *   
 *   Copyright 2004 H. Peter Anvin - All Rights Reserved
 *
 *   Permission is hereby granted, free of charge, to any person
 *   obtaining a copy of this software and associated documentation
 *   files (the "Software"), to deal in the Software without
 *   restriction, including without limitation the rights to use,
 *   copy, modify, merge, publish, distribute, sublicense, and/or
 *   sell copies of the Software, and to permit persons to whom
 *   the Software is furnished to do so, subject to the following
 *   conditions:
 *   
 *   The above copyright notice and this permission notice shall
 *   be included in all copies or substantial portions of the Software.
 *   
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 *   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 *   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 *   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 *   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 *   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 *   OTHER DEALINGS IN THE SOFTWARE.
 *
 * -----------------------------------------------------------------------
 * 21-07-2008 by xlq:
 *  added relevant #includes
 *  a few tweaks to compile cleanly with -Wall
 */

#include "stdio.h"
#include "stdarg.h"
#include "unistd.h"
#include "string.h"

enum flags {
    FL_ZERO       = 0x01,  // zero modifier
    FL_MINUS      = 0x02,  // minus modifier
    FL_PLUS       = 0x04,  // plus modifier
    FL_TICK       = 0x08,  // ' modifier
    FL_SPACE      = 0x10,  // space modifier
    FL_HASH       = 0x20,  // # modifier
    FL_SIGNED     = 0x40,  // number is signed
    FL_UPPER      = 0x80   // upper case digits
};

// these may have to be adjusted on certain implementations
enum ranks {
    rank_char     = -2,
    rank_short    = -1,
    rank_int      = 0,
    rank_long     = 1,
    rank_longlong = 2
};

typedef unsigned long long uintmax_t; // is this correct?
typedef signed long long intmax_t;
typedef unsigned long uintptr_t;
#define CHAR_BIT 8

#define MIN_RANK rank_char
#define MAX_RANK rank_longlong
#define INTMAX_RANK rank_longlong
#define SIZE_T_RANK rank_long
#define PTRDIFF_T_RANK rank_long
//#define EMIT(x) ({ if (o<n){*q++ = (x);} o++; })
// modification by xlq: avoid using non-standard statement-expression
#define EMIT(x) do { if (o<n){*q++ = (x);} o++; } while(0)

static size_t format_int(char *q, size_t n, uintmax_t val, enum flags flags, int base, int width, int prec)
{
    char *qq;
    size_t o = 0, oo;
    static const char lcdigits[] = "0123456789abcdef";
    static const char ucdigits[] = "0123456789ABCDEF";
    const char *digits;
    uintmax_t tmpval;
    int minus = 0;
    int ndigits = 0, nchars;
    int tickskip, b4tick;
    
    // select type of digits
    digits = (flags & FL_UPPER) ? ucdigits : lcdigits;

    // if signed, seperate out the minus
    if (flags & FL_SIGNED && (intmax_t) val < 0){
        minus = 1;
        val = (uintmax_t) (-(intmax_t) val);
    }

    // count the number of digits needed.
    tmpval = val;
    while (tmpval){
        tmpval /= base;
        ndigits++;
    }

    // adjust ndigits for size of output
    if (flags & FL_HASH && base == 8){
        if (prec < ndigits + 1)
            prec = ndigits + 1;
    }

    if (ndigits < prec)
        ndigits = prec;   // mandatory number padding
    else if (val == 0)
        ndigits = 1;      // zero still requires space

    // for ', figure out what the skip should be
    if (flags & FL_TICK)
        tickskip = (base == 16) ? 4 : 3;
    else
        tickskip = ndigits;   // no tick marks
    
    // tick marks aren't digits, but generated by the number converter
    ndigits += (ndigits - 1) / tickskip;

    // now compute the number of nondigits
    nchars = ndigits;

    if (minus || (flags & (FL_PLUS | FL_SPACE)))
        nchars++;            // need space for sign
    if ((flags & FL_HASH) && base == 16)
        nchars += 2;         // add 0x for hex
    
    // emit early space padding
    if (!(flags & (FL_MINUS | FL_ZERO)) && width > nchars){
        while (width > nchars){
            EMIT(' ');
            width--;
        }
    }

    // emit nondigits
    if (minus)
        EMIT('-');
    else if (flags & FL_PLUS)
        EMIT('+');
    else if (flags & FL_SPACE)
        EMIT(' ');

    if ((flags & FL_HASH) && base == 16){
        EMIT('0');
        EMIT('x');
    }

    // emit zero padding
    if ((flags & (FL_MINUS | FL_ZERO)) == FL_ZERO && width > ndigits){
        while (width > nchars){
            EMIT('0');
            width--;
        }
    }

    // generate the number. This is done from right to left
    q += ndigits;     // advance the pointer to end of number
    o += ndigits;
    qq = q;           // temporary values
    oo = o;

    b4tick = tickskip;
    while (ndigits > 0){
        if (!b4tick--){
            qq--, oo--, ndigits--;
            if (oo < n)
                *qq = '_';
            b4tick = tickskip - 1;
        }
        qq--, oo--, ndigits--;
        if (oo < n)
            *qq = digits[val % base];
        //*qq = digits[val % base];
        val /= base;
    }

    // emit late space padding
    while ((flags & FL_MINUS) && width > nchars){
        EMIT(' ');
        width--;
    }
    return o;
}

int vsnprintf(char *buffer, size_t n, const char *fmt, va_list ap)
{
    const char *p = fmt;
    char ch, *q = buffer;
    size_t o = 0; // number of characters output
    uintmax_t val = 0;
    int rank = rank_int; // default rank
    int width = 0, prec = -1, base;
    size_t sz;
    enum flags flags = 0;
    enum {
        st_normal,    // ground state
        st_flags,     // special flags
        st_width,     // field width
        st_prec,      // field precision
        st_modifiers  // length of conversion modifiers
    } state = st_normal;
    const char *sarg; // %s string argument
    char carg;        // %c char argument
    int slen;         // string length
    
    while ((ch = *p++)){
        switch (state){
            case st_normal:
                if (ch == '%'){
                    state = st_flags;
                    flags = 0;
                    rank = rank_int;
                    width = 0;
                    prec = -1;
                } else {
                    EMIT(ch);
                }
                break;
            case st_flags:
                switch (ch){
                    case '-':
                        flags |= FL_MINUS;
                        break;
                    case '+':
                        flags |= FL_PLUS;
                        break;
                    case '\'':
                        flags |= FL_TICK;
                        break;
                    case ' ':
                        flags |= FL_SPACE;
                        break;
                    case '#':
                        flags |= FL_HASH;
                        break;
                    case '0':
                        flags |= FL_ZERO;
                        break;
                    default:
                        state = st_width;
                        p--; // process this character again
                        break;
                }
                break;
            case st_width:
                if (ch >= '0' && ch <= '9')
                    width = width * 10 + (ch - '0');
                else if (ch == '*'){
                    width = va_arg(ap, int);
                    if (width < 0){
                        width = -width;
                        flags |= FL_MINUS;
                    }
                } else if (ch == '.'){
                    prec = 0; // precision given
                    state = st_prec;
                } else {
                    state = st_modifiers;
                    p--; // process this character again
                }
                break;
            case st_prec:
                if (ch >= '0' && ch <+ '9')
                    prec = prec * 10 + (ch - '0');
                else if (ch == '*'){
                    prec = va_arg(ap, int);
                    if (prec < 0)
                        prec = -1;
                } else {
                    state = st_modifiers;
                    p--; // process this character again
                }
                break;
            case st_modifiers:
                switch (ch){
                    // length modifiers - nonterminal sequences
                    case 'h':
                        rank--; // shorter rank
                        break;
                    case 'l':
                        rank++; // longer rank
                        break;
                    case 'j':
                        rank = INTMAX_RANK;
                        break;
                    case 'z':
                        rank = SIZE_T_RANK;
                        break;
                    case 't':
                        rank = PTRDIFF_T_RANK;
                        break;
                    case 'L':
                    case 'q':
                        rank += 2;
                        break;
                    default:
                        // output modifiers - terminal sequences
                        // next state will be normal
                        state = st_normal;

                        // Canonicalize rank, whatever that means
                        if (rank < MIN_RANK)
                            rank = MIN_RANK;
                        else if (rank > MAX_RANK)
                            rank = MAX_RANK;

                        switch (ch){
                            case 'P': // upper case pointer
                                flags |= FL_UPPER;
                            case 'p':
                                base = 16;
                                prec = (CHAR_BIT * sizeof(void *) + 3) / 4;
                                flags |= FL_HASH;
                                val = (uintmax_t)(uintptr_t)va_arg(ap, void *);
                                goto is_integer;
                            case 'd': // signed decimal output
                            case 'i':
                                base = 10;
                                flags |= FL_SIGNED;
                                switch (rank){
                                    case rank_char:
                                        // yes, all these casts are needed
                                        val = (uintmax_t)(intmax_t)(signed char) va_arg(ap, signed int);
                                        break;
                                    case rank_short:
                                        val = (uintmax_t)(intmax_t)(signed short) va_arg(ap, signed int);
                                        break;
                                    case rank_int:
                                        val = (uintmax_t)(intmax_t) va_arg(ap, signed int);
                                        break;
                                    case rank_long:
                                        val = (uintmax_t)(intmax_t) va_arg(ap, signed long);
                                        break;
                                    case rank_longlong:
                                        val = (uintmax_t)(intmax_t) va_arg(ap, signed long long);
                                        break;
                                }
                                goto is_integer;
                            case 'o': // octal
                                base = 8;
                                goto is_unsigned;
                            case 'u': // unsigned decimal
                                base = 10;
                                goto is_unsigned;
                            case 'X': // upper case hexadecimal
                                flags |= FL_UPPER;
                            case 'x': // hexadecimal
                                base = 16;
                                goto is_unsigned;
                            is_unsigned:
                                switch (rank){
                                    case rank_char:
                                        val = (uintmax_t)(unsigned char) va_arg(ap, unsigned int);
                                        break;
                                    case rank_short:
                                        val = (uintmax_t)(unsigned short) va_arg(ap, unsigned int);
                                        break;
                                    case rank_int:
                                        val = (uintmax_t) va_arg(ap, unsigned int);
                                        break;
                                    case rank_long:
                                        val = (uintmax_t) va_arg(ap, unsigned long);
                                        break;
                                    case rank_longlong:
                                        val = (uintmax_t) va_arg(ap, unsigned long long);
                                        break;
                                }
                            is_integer:
                                sz = format_int(q, (o < n) ? n - o : 0, val, flags, base, width, prec);
                                q += sz;
                                o += sz;
                                break;
                            case 'c': // character
                                carg = (char) va_arg(ap, int);
                                sarg = &carg;
                                slen = 1;
                                goto is_string;
                            case 's': // string
                                sarg = va_arg(ap, const char *);
                                sarg = sarg ? sarg : "(null)";
                                slen = strlen(sarg);
                                goto is_string;
                            is_string:
                                {
                                    char sch;
                                    int i;

                                    if (prec != -1 && slen > prec)
                                        slen = prec;
                                    if (width > slen && !(flags & FL_MINUS)){
                                        char pad = (flags & FL_ZERO) ? '0' : ' ';
                                        while (width > slen){
                                            EMIT(pad);
                                            width--;
                                        }
                                    }
                                    for (i=slen; i; i--){
                                        sch = *sarg++;
                                        EMIT(sch);
                                    }
                                    if (width > slen && (flags & FL_MINUS)){
                                        while (width > slen){
                                            EMIT(' ');
                                            width--;
                                        }
                                    }
                                }
                                break;
                            case 'n':
                                {
                                    // output the number of characters written
                                    switch (rank){
                                        case rank_char:
                                            *va_arg(ap, signed char *) = o;
                                            break;
                                        case rank_short:
                                            *va_arg(ap, signed short *) = o;
                                            break;
                                        case rank_int:
                                            *va_arg(ap, signed int *) = o;
                                            break;
                                        case rank_long:
                                            *va_arg(ap, signed long *) = o;
                                            break;
                                        case rank_longlong:
                                            *va_arg(ap, signed long long *) = o;
                                            break;
                                    }
                                }
                                break;
                            default: // anything else, including %
                                EMIT(ch);
                                break;
                        }
                }
        }
    }

    // null-terminate the string
    if (o < n)
        *q = '\0'; // no overflow
    else if (n > 0)
        buffer[n - 1] = '\0'; // overflow - terminate at end of buffer
    return o;
}

int snprintf(char *str, size_t n, const char *fmt, ...)
{
    int retval;
    va_list ap;
    va_start(ap, fmt);
    retval = vsnprintf(str, n, fmt, ap);
    va_end(ap);
    return retval;
}

int vsprintf(char *str, const char *fmt, va_list ap)
{
    return vsnprintf(str, (unsigned) -1, fmt, ap);
}

int sprintf(char *str, const char *fmt, ...)
{
    int retval;
    va_list ap;
    va_start(ap, fmt);
    retval = vsnprintf(str, (unsigned) -1, fmt, ap);
    va_end(ap);
    return retval;
}

